searchNodes=[{"doc":"Authentication &amp; sessions for API's.","ref":"Charon.html","title":"Charon","type":"module"},{"doc":"Config struct. All config is read at runtime. So if, for example, you wish to override :session_ttl based on the username, you can simply alter the config struct in your code. That being said, config that HAS to be read at runtime, like secrets, is stored as a getter to emphasize the fact and prevent you from accidentally setting a compile-time value even if you put the config struct in a module attribute. That is why the base secret has to be passed in via :get_base_secret . Keys &amp; defaults [ :token_issuer , :get_base_secret , access_cookie_name : &quot;_access_token_signature&quot; , access_cookie_opts : [ http_only : true , same_site : &quot;Strict&quot; , secure : true ] , # 15 minutes access_token_ttl : 15 * 60 , enforce_browser_cookies : false , json_module : Jason , optional_modules : %{ } , refresh_cookie_name : &quot;_refresh_token_signature&quot; , refresh_cookie_opts : [ http_only : true , same_site : &quot;Strict&quot; , secure : true ] , # 2 months refresh_token_ttl : 2 * 30 * 24 * 60 * 60 , session_store_module : Charon.SessionStore.RedisStore , # 1 year session_ttl : 365 * 24 * 60 * 60 , token_factory_module : Charon.TokenFactory.Jwt ] Glossary :access_cookie_name Name of the cookie in which the access token or its signature is stored. :access_cookie_opts Options passed to Plug.Conn.put_resp_cookie/3 . Note that :max_age is set by Charon.SessionPlugs based on the token TTL. Overrides are merged into the defaults. :access_token_ttl Time in seconds until a new access token expires. This time may be reduced so that the token does not outlive its session. :enforce_browser_cookies If a browser client is detected, enforce that tokens are not returned to it as fully valid bearer tokens, but are transported (wholly or in part) as cookies. :get_base_secret Getter for Charon's base secret from which other keys are derived. Make sure it has large entropy (&gt;= 256 bits). For example fn -&gt; Application.get_env(:my_app, :charon_secret) end . :json_module The JSON module, like Jason or Poison . :optional_modules Configuration for optional modules, like Charon.TokenFactory.Jwt or CharonOauth2 . See the optional module's docs for info on its configuration options. :refresh_cookie_name Name of the cookie in which the refresh token or its signature is stored. :refresh_cookie_opts Options passed to Plug.Conn.put_resp_cookie/3 . Note that :max_age is set by Charon.SessionPlugs based on the token TTL. Overrides are merged into the defaults. :refresh_token_ttl Time in seconds until a new refresh token expires. This time may be reduced so that the token does not outlive its session. :session_store_module A module that implements Charon.SessionStore.Behaviour , used to store sessions. :session_ttl Time in seconds until a new session expires OR :infinite for non-expiring sessions. :token_factory_module A module that implements Charon.TokenFactory.Behaviour , used to create and verify authentication tokens. :token_issuer Value of the &quot;iss&quot; claim in tokens, for example &quot; https://myapp.com&quot;","ref":"Charon.Config.html","title":"Charon.Config","type":"module"},{"doc":"Build config struct from enumerable (useful for passing in application environment). Raises for missing mandatory keys and sets defaults for optional keys. Optional modules must implement an init_config/1 function to process their own config at compile time. Examples / doctests iex&gt; from_enum ( [ ] ) ** (ArgumentError) the following keys must also be given when building struct Charon.Config: [:token_issuer, :get_base_secret] iex&gt; % Charon.Config { } = from_enum ( token_issuer : &quot;https://myapp&quot; , get_base_secret : &quot;supersecure&quot; )","ref":"Charon.Config.html#from_enum/1","title":"Charon.Config.from_enum/1","type":"function"},{"doc":"","ref":"Charon.Config.html#t:t/0","title":"Charon.Config.t/0","type":"type"},{"doc":"A session.","ref":"Charon.Models.Session.html","title":"Charon.Models.Session","type":"module"},{"doc":"Upgrade a session (or map created from a session struct) to the latest struct version (7). DocTests @charon_config Charon.Config . from_enum ( token_issuer : &quot;local&quot; ) # old version without the :version, :refesh_expires_at fields but with :__struct__ set # is updated to latest version (7) iex&gt; session = %{ ...&gt; __struct__ : Session , ...&gt; created_at : 0 , ...&gt; expires_at : 1 , ...&gt; extra_payload : %{ } , ...&gt; id : &quot;ab&quot; , ...&gt; refresh_token_id : &quot;cd&quot; , ...&gt; refreshed_at : 15 , ...&gt; type : :full , ...&gt; user_id : 9 ...&gt; } ...&gt; |&gt; upgrade_version ( @charon_config ) iex&gt; % Session { ...&gt; created_at : 0 , ...&gt; expires_at : 1 , ...&gt; extra_payload : %{ } , ...&gt; id : &quot;ab&quot; , ...&gt; prev_tokens_fresh_from : 0 , ...&gt; refresh_expires_at : 1 , ...&gt; refresh_token_id : &quot;cd&quot; , ...&gt; refreshed_at : 15 , ...&gt; tokens_fresh_from : 15 , ...&gt; type : :full , ...&gt; user_id : 9 , ...&gt; version : 7 ...&gt; } = session # old version - with :expires_at = nil - is updated without error iex&gt; session = %{ ...&gt; __struct__ : Session , ...&gt; created_at : 0 , ...&gt; expires_at : nil , ...&gt; extra_payload : %{ } , ...&gt; id : &quot;ab&quot; , ...&gt; refresh_token_id : &quot;cd&quot; , ...&gt; refreshed_at : 15 , ...&gt; type : :full , ...&gt; user_id : 9 ...&gt; } ...&gt; |&gt; upgrade_version ( @charon_config ) iex&gt; % Session { ...&gt; created_at : 0 , ...&gt; expires_at : :infinite , ...&gt; extra_payload : %{ } , ...&gt; id : &quot;ab&quot; , ...&gt; prev_tokens_fresh_from : 0 , ...&gt; refresh_expires_at : refresh_exp , ...&gt; refresh_token_id : &quot;cd&quot; , ...&gt; refreshed_at : 15 , ...&gt; tokens_fresh_from : 15 , ...&gt; type : :full , ...&gt; user_id : 9 , ...&gt; version : 7 ...&gt; } = session iex&gt; is_integer ( refresh_exp ) and refresh_exp &gt;= System . os_time ( :second ) true","ref":"Charon.Models.Session.html#upgrade_version/2","title":"Charon.Models.Session.upgrade_version/2","type":"function"},{"doc":"","ref":"Charon.Models.Session.html#t:t/0","title":"Charon.Models.Session.t/0","type":"type"},{"doc":"Tokens to be communicated to the client.","ref":"Charon.Models.Tokens.html","title":"Charon.Models.Tokens","type":"module"},{"doc":"","ref":"Charon.Models.Tokens.html#t:t/0","title":"Charon.Models.Tokens.t/0","type":"type"},{"doc":"Plugs to create, update/refresh and delete sessions. When creating or updating a session, new tokens are created as well.","ref":"Charon.SessionPlugs.html","title":"Charon.SessionPlugs","type":"module"},{"doc":"Delete the persistent session identified by the session_id in the token claims. Note that the token remains valid until it expires, it is left up to the client to drop the access token. It will no longer be possible to refresh the session, however. Examples / doctests # instructs browsers to clear signature cookies iex&gt; conn ( ) ...&gt; |&gt; Plug.Test . put_req_cookie ( @config . access_cookie_name , &quot;anything&quot; ) ...&gt; |&gt; Plug.Test . put_req_cookie ( @config . refresh_cookie_name , &quot;anything&quot; ) ...&gt; |&gt; delete_session ( @config ) ...&gt; |&gt; Conn . fetch_cookies ( ) ...&gt; |&gt; Map . get ( :cookies ) %{ }","ref":"Charon.SessionPlugs.html#delete_session/2","title":"Charon.SessionPlugs.delete_session/2","type":"function"},{"doc":"Create or update a session. If a session exists in the conn, the session is updated / refreshed, otherwise a new one is created. Refresh an existing session by putting it on the connection with Charon.TokenPlugs.load_session/2 . In both cases, new access / refresh tokens are created and stored in the conn's private map. The server-side session stored in the session store is created / updated as well. If a new session is created, options :user_id and :token_transport must be provided or an error will be raised. The token transport can be: :cookie_only - tokens are returned to the client as cookies :cookie - tokens' signatures are split from the tokens and sent as http-only strictly-same-site secure cookies :bearer - tokens are left as-is for the implementing application to return to the client If config option :enforce_browser_cookies is enabled, browser clients will be attempted to be detected by the presence of (forbidden) header &quot;Sec-Fetch-Mode&quot;, in which case only cookie-based token transports will be allowed. This feature is experimental and disabled by default, although this may change in a future release. Optionally, it is possible to add extra claims to the access- and refresh tokens or to store extra payload in the server-side session. Session stores may return an optimistic locking error, meaning there are concurrent updates to a session. In this case, upsert/3 will raise a Charon.SessionPlugs.SessionUpdateConflictError , which should result in an HTTP 409 Conflict error. If the session store returns another error, a Charon.SessionPlugs.SessionStorageError is raised, which is an unrecoverable state that should result in an HTTP 500 Internal Server Error. Claims The following claims are set by default: &quot;exp&quot; expires at (this value is guaranteed to never outlive the session itself) &quot;iat&quot; time of token creation &quot;iss&quot; issuer, usually a url like &quot; https://myapp.com&quot; &quot;jti&quot; jwt id, random unique id for the token (a refresh token's id is stored in the session as well) &quot;nbf&quot; not before, same value as &quot;iat&quot; but means &quot;token not valid before this time&quot; &quot;sid&quot; session id &quot;sub&quot; subject, the user id of the session owner &quot;type&quot; type, &quot;access&quot; or &quot;refresh&quot; &quot;styp&quot; session type Additional claims or overrides can be provided with opts . Examples / doctests # error if user id not set for new session iex&gt; upsert_session ( conn ( ) , @config , token_transport : :bearer ) ** (RuntimeError) Set user id using upsert_session/3 option :user_id # error if signature transport not set for new session iex&gt; upsert_session ( conn ( ) , @config , user_id : 1 ) ** (RuntimeError) Set token transport using upsert_session/3 option :token_transport # creates session if none present in conn iex&gt; conn = upsert_session ( conn ( ) , @config , user_id : 1 , token_transport : :bearer ) iex&gt; % Session { } = Utils . get_session ( conn ) iex&gt; % Tokens { } = Utils . get_tokens ( conn ) # works with infinite lifespan sessions iex&gt; conn = upsert_session ( conn ( ) , %{ @config | session_ttl : :infinite } , user_id : 1 , token_transport : :bearer ) iex&gt; % Session { expires_at : :infinite } = Utils . get_session ( conn ) iex&gt; % Tokens { } = Utils . get_tokens ( conn ) # renews session if present in conn, updating only refresh_tokens, refreshed_at, and refresh_expires_at # existing session&#39;s user id will not change despite attempted override iex&gt; old_session = test_session ( user_id : 43 , id : &quot;a&quot; , expires_at : :infinite , refresh_expires_at : 0 , refreshed_at : 0 ) iex&gt; conn = conn ( ) ...&gt; |&gt; Conn . put_private ( @session , old_session ) ...&gt; |&gt; upsert_session ( @config , user_id : 1 , token_transport : :bearer ) iex&gt; session = Utils . get_session ( conn ) |&gt; Map . from_struct ( ) iex&gt; old_session = Map . from_struct ( old_session ) iex&gt; Enum . find ( ~w(id user_id created_at expires_at)a , &amp; session [ &amp;1 ] != old_session [ &amp;1 ] ) nil iex&gt; Enum . find ( ~w(refresh_token_id refreshed_at refresh_expires_at)a , &amp; session [ &amp;1 ] == old_session [ &amp;1 ] ) nil # returns token signatures in cookies if token transport is :cookie # cookie options are merged with defaults iex&gt; conn = upsert_session ( conn ( ) , @config , user_id : 1 , token_transport : :cookie ) iex&gt; cookies = conn |&gt; Conn . fetch_cookies ( ) |&gt; Map . get ( :cookies ) iex&gt; &lt;&lt; _access_sig :: binary &gt;&gt; = Map . get ( cookies , @config . access_cookie_name ) iex&gt; &lt;&lt; _refresh_sig :: binary &gt;&gt; = Map . get ( cookies , @config . refresh_cookie_name ) iex&gt; tokens = Utils . get_tokens ( conn ) iex&gt; [ _ , _ ] = String . split ( tokens . access_token , &quot;.&quot; , trim : true ) iex&gt; [ _ , _ ] = String . split ( tokens . refresh_token , &quot;.&quot; , trim : true ) iex&gt; %{ http_only : true , path : _ , same_site : &quot;Strict&quot; , secure : true , max_age : _ } = conn . resp_cookies [ &quot;_refresh_token_signature&quot; ] # returns full tokens in cookies if token transport is :cookie_only iex&gt; conn = upsert_session ( conn ( ) , @config , user_id : 1 , token_transport : :cookie_only ) iex&gt; cookies = conn |&gt; Conn . fetch_cookies ( ) |&gt; Map . get ( :cookies ) iex&gt; [ _ , _ , _ ] = cookies |&gt; Map . get ( @config . access_cookie_name ) |&gt; String . split ( &quot;.&quot; , trim : true ) iex&gt; [ _ , _ , _ ] = cookies |&gt; Map . get ( @config . refresh_cookie_name ) |&gt; String . split ( &quot;.&quot; , trim : true ) iex&gt; %{ access_token : nil , refresh_token : nil } = Utils . get_tokens ( conn ) # tokens get a lot of default claims iex&gt; conn = upsert_session ( conn ( ) , @config , user_id : 1 , token_transport : :bearer ) iex&gt; %{ &quot;exp&quot; =&gt; _ , &quot;iat&quot; =&gt; _ , &quot;iss&quot; =&gt; &quot;my_test_app&quot; , &quot;jti&quot; =&gt; &lt;&lt; _ :: binary &gt;&gt; , &quot;nbf&quot; =&gt; _ , &quot;sid&quot; =&gt; &lt;&lt; sid :: binary &gt;&gt; , &quot;sub&quot; =&gt; 1 , &quot;type&quot; =&gt; &quot;access&quot; , &quot;styp&quot; =&gt; &quot;full&quot; } = get_private ( conn , @access_token_payload ) iex&gt; %{ &quot;exp&quot; =&gt; _ , &quot;iat&quot; =&gt; _ , &quot;iss&quot; =&gt; &quot;my_test_app&quot; , &quot;jti&quot; =&gt; &lt;&lt; _ :: binary &gt;&gt; , &quot;nbf&quot; =&gt; _ , &quot;sid&quot; =&gt; ^ sid , &quot;sub&quot; =&gt; 1 , &quot;type&quot; =&gt; &quot;refresh&quot; , &quot;styp&quot; =&gt; &quot;full&quot; } = get_private ( conn , @refresh_token_payload ) # allows adding extra claims to tokens iex&gt; conn = upsert_session ( ...&gt; conn ( ) , ...&gt; @config , ...&gt; user_id : 1 , ...&gt; token_transport : :bearer , ...&gt; access_claim_overrides : %{ &quot;much&quot; =&gt; :extra } , ...&gt; refresh_claim_overrides : %{ &quot;really&quot; =&gt; true } ...&gt; ) iex&gt; %{ &quot;much&quot; =&gt; :extra } = get_private ( conn , @access_token_payload ) iex&gt; %{ &quot;really&quot; =&gt; true } = get_private ( conn , @refresh_token_payload ) # allows adding extra payload to session iex&gt; conn = upsert_session ( ...&gt; conn ( ) , ...&gt; @config , ...&gt; user_id : 1 , ...&gt; token_transport : :bearer , ...&gt; extra_session_payload : %{ what? : &quot;that&#39;s right!&quot; } ...&gt; ) iex&gt; % Session { extra_payload : %{ what? : &quot;that&#39;s right!&quot; } } = Utils . get_session ( conn ) # allows separating sessions by type (default :full) iex&gt; conn = upsert_session ( conn ( ) , @config , session_type : :oauth2 , user_id : 1 , token_transport : :bearer ) iex&gt; % Session { type : :oauth2 } = Utils . get_session ( conn ) iex&gt; %{ &quot;styp&quot; =&gt; &quot;oauth2&quot; } = get_private ( conn , @access_token_payload )","ref":"Charon.SessionPlugs.html#upsert_session/3","title":"Charon.SessionPlugs.upsert_session/3","type":"function"},{"doc":"","ref":"Charon.SessionPlugs.html#t:upsert_session_opts/0","title":"Charon.SessionPlugs.upsert_session_opts/0","type":"type"},{"doc":"The persistent session store. See Charon.SessionStore.Behaviour for callbacks. All functions delegate to the configured session store module. Client applications should use this module to interact with the underlying implementation, because this module takes care of session struct version upgrades as well.","ref":"Charon.SessionStore.html","title":"Charon.SessionStore","type":"module"},{"doc":"Behaviour definition of a persistent session store. Clients should not use the implementation directly, but should use Charon.SessionStore . Implementation guidelines Implementations are expected to store sessions by ID, user ID and session type. For the optional callbacks get_all/3 and delete_all/3 , sessions should be retrievable by user ID and session type only. Implementations should return the session exactly as it went in (they don't have to take care of struct version upgrades). Implementations should handle cleanup of expired entries, but may define additional functions and instructions to take care of such things (like a cleanup/0 that should run periodically). Implementations should implement optimistic locking with respect to the :lock_version field of the session struct. On an update, the lock version of the updated session should match the lock version of the existing session. If that is the case, the implementation should increase :lock_version and proceed with the update. If not, the implementation should abort the update and return {:error, :conflict} .","ref":"Charon.SessionStore.Behaviour.html","title":"Charon.SessionStore.Behaviour","type":"behaviour"},{"doc":"Delete session of type type with id session_id for user with id user_id . Implementations may choose to ignore user_id , since session_id is unique by itself.","ref":"Charon.SessionStore.Behaviour.html#c:delete/4","title":"Charon.SessionStore.Behaviour.delete/4","type":"callback"},{"doc":"Delete all sessions of type type for the user with id user_id .","ref":"Charon.SessionStore.Behaviour.html#c:delete_all/3","title":"Charon.SessionStore.Behaviour.delete_all/3","type":"callback"},{"doc":"Get session of type type with id session_id for user with id user_id . Must not return sessions that have expired, or that can't be refreshed anymore because the refresh token has expired. Implementations may choose to ignore user_id , since session_id is unique by itself.","ref":"Charon.SessionStore.Behaviour.html#c:get/4","title":"Charon.SessionStore.Behaviour.get/4","type":"callback"},{"doc":"Get all sessions of type type for the user with id user_id . Must not return sessions that have expired, or that can't be refreshed anymore because the refresh token has expired.","ref":"Charon.SessionStore.Behaviour.html#c:get_all/3","title":"Charon.SessionStore.Behaviour.get_all/3","type":"callback"},{"doc":"Insert or update session . If the implementation supports optimistic locking, it will return {:error, :conflict} on an optimistic locking conflict. Values session_id , user_id and type are taken from the session struct. Implementations may choose to ignore user_id , since session_id is unique by itself. Implementations may assume that Charon.SessionPlugs.upsert_session/3 will ensure that: :refreshed_at contains the current unix timestamp :refresh_expires_at never exceeds :expires_at","ref":"Charon.SessionStore.Behaviour.html#c:upsert/2","title":"Charon.SessionStore.Behaviour.upsert/2","type":"callback"},{"doc":"A dummy session store that can be used if fully stateless tokens are desired.","ref":"Charon.SessionStore.DummyStore.html","title":"Charon.SessionStore.DummyStore","type":"module"},{"doc":"An in-memory persistent session store, implements behaviour Charon.SessionStore . In addition to the required callbacks, this store also provides get_all/3 and delete_all/3 (for a user) functions. Usage Add this store to your supervision tree to use it. children = [ Charon.SessionStore.LocalStore ]","ref":"Charon.SessionStore.LocalStore.html","title":"Charon.SessionStore.LocalStore","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Charon.SessionStore.LocalStore.html#child_spec/1","title":"Charon.SessionStore.LocalStore.child_spec/1","type":"function"},{"doc":"","ref":"Charon.SessionStore.LocalStore.html#start_link/1","title":"Charon.SessionStore.LocalStore.start_link/1","type":"function"},{"doc":"A persistent session store based on Redis, which implements behaviour Charon.SessionStore . In addition to the required callbacks, this store also provides get_all/3 and delete_all/3 (for a user) functions. Redis requirements This module needs a Redis &gt;= 7.0.0 instance and needs permissions to create Redis functions. The optimistic-locking functionality of the store was not designed with a Redis cluster in mind and will behave unpredictably when used with a distributed Redis deployment. Using a failover-replica should be fine, however. The Redis functions are registered with a name that includes the hashed Charon version, to make sure that the called function matches the expected code, and multiple Charon deployments can share a Redis instance. Config Additional config is required for this module (see Charon.SessionStore.RedisStore.Config ): Charon.Config . from_enum ( ... , optional_modules : %{ Charon.SessionStore.RedisStore =&gt; %{ key_prefix : &quot;charon_&quot; , get_signing_key : &amp; RedisStore . default_signing_key / 1 } } ) The following options are supported: :key_prefix (optional). A string prefix for the Redis keys that are sessions. :get_signing_key (optional). A getter/1 that returns the key that is used to sign and verify serialized session binaries. Initialize store RedisStore uses a connection pool and has to register Redis functions on startup. In order to initialize it, you must add RedisStore to your application's supervision tree. # in application.ex def start ( _ , ) do redix_opts = [ host : &quot;localhost&quot; , port : 6379 , password : &quot;supersecret&quot; , database : 0 ] children = [ ... { Charon.SessionStore.RedisStore , pool_size : 15 , redix_opts : redix_opts } , ... ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end Options :name (default module name) name of the supervisor :pool_size (default 10) total number of (local) normal workers :pool_max_overflow (default 5) max number of (local) extra workers in case of high load :redix_opts passed to Redix.start_link/1 The pool and its config options are local to the Elixir/OTP node, so if you use multiple nodes, the total connection count to Redis maxes out at (pool_size + pool_max_overflow) * number_of_nodes . Session signing In order to offer some defense-in-depth against a compromised Redis server, the serialized sessions are signed using a HMAC. The key is derived from the Charon base secret, but can be overridden in the config. This is not usually necessary, except when you're changing the base secret and still want to access your sessions. It is debatable, of course, in case your Redis server is compromised, if your application server holding the signing key can still be considered secure. However, given that there are no real drawbacks to using signed session binaries, since the performance cost is negligible, no extra config is needed, it is easy to implement, and defense-in-depth is a good guiding principle, RedisStore implements this feature anyway. Implementation details RedisStore stores sessions until their associated refresh token(s) expire. That means that :refresh_expires_at is used to determine if a session is &quot;alive&quot;, not :expires_at . This makes sense, because a session without a valid refresh token is effectively useless, and it means we can support &quot;infinite lifetime&quot; sessions while still pruning sessions that aren't used. This is one reason to set :refresh_ttl to a limited value, no more than six months is recommended. Last but not least, Redis 7 functions are used to implement some features, specifically optimistic locking, and to ensure all callbacks use only a single round-trip to the Redis instance.","ref":"Charon.SessionStore.RedisStore.html","title":"Charon.SessionStore.RedisStore","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Charon.SessionStore.RedisStore.html#child_spec/1","title":"Charon.SessionStore.RedisStore.child_spec/1","type":"function"},{"doc":"Get the default session signing key that is used if config option :get_signing_key is not set explicitly.","ref":"Charon.SessionStore.RedisStore.html#default_signing_key/1","title":"Charon.SessionStore.RedisStore.default_signing_key/1","type":"function"},{"doc":"Start the RedisStore supervisor, which registeres all required Redis functions and initiates the connection pool. Options :name (default module name) name of the supervisor :pool_size (default 10) total number of (local) normal workers :pool_max_overflow (default 5) max number of (local) extra workers in case of high load :redix_opts passed to Redix.start_link/1 The pool and its config options are local to the Elixir/OTP node, so if you use multiple nodes, the total connection count to Redis maxes out at (pool_size + pool_max_overflow) * number_of_nodes .","ref":"Charon.SessionStore.RedisStore.html#start_link/1","title":"Charon.SessionStore.RedisStore.start_link/1","type":"function"},{"doc":"Config module for Charon.SessionStore.RedisStore .","ref":"Charon.SessionStore.RedisStore.Config.html","title":"Charon.SessionStore.RedisStore.Config","type":"module"},{"doc":"Build config struct from enumerable (useful for passing in application environment). Raises for missing mandatory keys and sets defaults for optional keys.","ref":"Charon.SessionStore.RedisStore.Config.html#from_enum/1","title":"Charon.SessionStore.RedisStore.Config.from_enum/1","type":"function"},{"doc":"Get the config for this module from the parent Charon.Config struct.","ref":"Charon.SessionStore.RedisStore.Config.html#get_mod_config/1","title":"Charon.SessionStore.RedisStore.Config.get_mod_config/1","type":"function"},{"doc":"","ref":"Charon.SessionStore.RedisStore.Config.html#t:t/0","title":"Charon.SessionStore.RedisStore.Config.t/0","type":"type"},{"doc":"Utility functions for writing tests.","ref":"Charon.TestHelpers.html","title":"Charon.TestHelpers","type":"module"},{"doc":"Create a test session and return the session, a set of tokens for it and the response cookies. Options :upsert_session_opts (default [] ) as defined in Charon.SessionPlugs.upsert_session_opts/0","ref":"Charon.TestHelpers.html#create_session/2","title":"Charon.TestHelpers.create_session/2","type":"function"},{"doc":"Override configuration for an optional module.","ref":"Charon.TestHelpers.html#override_opt_mod_conf/3","title":"Charon.TestHelpers.override_opt_mod_conf/3","type":"function"},{"doc":"Create a new test session and put a token (and its cookie when needed) on the conn. This is essentially create_session/3 and put_token_for/3 combined into one convenience function. Options The upsert_session_opts defined in Charon.SessionPlugs.upsert_session_opts/0 AND :token is either :access (default) or :refresh","ref":"Charon.TestHelpers.html#put_token/3","title":"Charon.TestHelpers.put_token/3","type":"function"},{"doc":"Put a token (and its cookie when needed) from the test session on the conn. Use create_session/3 to create the test session. Options :token is either :access (default) or :refresh","ref":"Charon.TestHelpers.html#put_token_for/3","title":"Charon.TestHelpers.put_token_for/3","type":"function"},{"doc":"","ref":"Charon.TestHelpers.html#t:test_session/0","title":"Charon.TestHelpers.test_session/0","type":"type"},{"doc":"Entrypoint for Charon.TokenFactory.Behaviour implementation. All functions delegate to the configured module.","ref":"Charon.TokenFactory.html","title":"Charon.TokenFactory","type":"module"},{"doc":"Behaviour for token-signing modules. Note that the token payload must be returned as a map with string keys on verification. When the payload is serialized as JSON, this happens automatically. However, when Erlang term format is used, this is not the case.","ref":"Charon.TokenFactory.Behaviour.html","title":"Charon.TokenFactory.Behaviour","type":"behaviour"},{"doc":"Create a new token with the provided payload and a valid signature.","ref":"Charon.TokenFactory.Behaviour.html#c:sign/2","title":"Charon.TokenFactory.Behaviour.sign/2","type":"callback"},{"doc":"Verify that the signature matches the token's header and payload, and decode the payload. Must return a map of string keys.","ref":"Charon.TokenFactory.Behaviour.html#c:verify/2","title":"Charon.TokenFactory.Behaviour.verify/2","type":"callback"},{"doc":"JWT's with either symmetric (HMAC) or asymmetric (EDDSA) signatures. The default, simplest and most performant option is symmetric signatures (MAC), with the key derived from the Charon base secret. Asymmetric tokens can be used when it is desirable for an external party to be able to verify a token's integrity, in which case distributing symmetric keys can be a hassle and a security risk. Keysets In order to sign and verify JWT's, a keyset is used. A keyset is a map of key ID's to keys. A key is a tuple of the signing algorithm and the actual secret(s). To simplify things and discourage key reuse, a key can only be used with a single signing algorithm. The default keyset looks like this, for example: %{ &quot;default&quot; =&gt; { :hmac_sha256 , &lt;&lt; 0 , ... &gt;&gt; } } Every token that is signed gets a &quot;kid&quot; claim in its header, allowing it to be verified with the specific key and algorithm that it was signed with. Key cycling It is possible to transition to a new signing key by adding a new key to the keyset and setting it as the new signing key using the :signing_key config option: %{ &quot;default&quot; =&gt; { :hmac_sha256 , &lt;&lt; 0 , ... &gt;&gt; } , &quot;new!&quot; =&gt; { :hmac_sha512 , &lt;&lt; 1 , ... &gt;&gt; } } Older tokens will be verified using the older key, based on their &quot;kid&quot; header claim. Tokens without a &quot;kid&quot; header claim Legacy or external tokens may not have a &quot;kid&quot; header claim. Such tokens can still be verified by adding a &quot;kid_not_set.&lt;alg&gt;&quot; (for example &quot;kid_not_set.HS256&quot;) key to the keyset. Symmetric signatures Symmetric signatures are message authentication codes or MACs, either HMACs based on SHA256, 384 or 512, or a MAC generated using Blake3's keyed-hashing mode , which can be used directly without using a HMAC wrapper. Using Blake3 requires the optional dependency Blake3 and a key of exactly 256 bits. By default, a SHA256-based HMAC is used. Asymmetric signatures Asymmetric signatures are created using EDDSA (Edwards-curve Digital Signature Algorithm) based on Curve25519 or Curve448. Use in JWTs is standardized (pending) in RFC 8073 . These algorithms were chosen for performance and implementation ease, since they offer built-in protection against many side-channel (timing) attacks and are not susceptible to nonce-reuse (technically, they are, but not on the part of the implementation, which means they are safe to use in your PlayStation ). Unless you are paranoid, use Curve25519, which offers about 128 bits of security. Curve448 offers about 224 bits, but is significantly slower. In order to use asymmetric signatures, generate a key using gen_keypair/1 . Create a publishable JWK using keypair_to_pub_jwk/1 . iex&gt; keypair = Jwt . gen_keypair ( :eddsa_ed25519 ) iex&gt; { :eddsa_ed25519 , { _pubkey , _privkey } } = keypair iex&gt; %{ &quot;crv&quot; =&gt; &quot;Ed25519&quot; , &quot;kty&quot; =&gt; &quot;OKP&quot; , &quot;x&quot; =&gt; &lt;&lt; _ :: binary &gt;&gt; } = Jwt . keypair_to_pub_jwk ( keypair ) Config Additional config is required for this module (see Charon.TokenFactory.Jwt.Config ): Charon.Config . from_enum ( ... , optional_modules : %{ Charon.TokenFactory.Jwt =&gt; %{ get_keyset : fn -&gt; %{ &quot;key1&quot; =&gt; { :hmac_sha256 , &quot;my_key&quot; } } end , signing_key : &quot;key1&quot; } } ) The following options are supported: :get_keyset (optional, default default_keyset/1 ). The keyset used to sign and verify JWTs. If not specified, a default keyset with a single key called &quot;default&quot; is used, which is derived from Charon's base secret. :signing_key (optional, default &quot;default&quot;). The ID of the key in the keyset that is used to sign new tokens. Examples / doctests # gracefully handles malformed tokens / unsupported algo&#39;s / invalid signature iex&gt; verify ( &quot;a&quot; , @charon_config ) { :error , &quot;malformed token&quot; } iex&gt; verify ( &quot;a.b.c&quot; , @charon_config ) { :error , &quot;encoding invalid&quot; } iex&gt; header = &quot;notjson&quot; |&gt; url_encode ( ) iex&gt; verify ( header &lt;&gt; &quot;.YQ.YQ&quot; , @charon_config ) { :error , &quot;json invalid&quot; } iex&gt; header = %{ &quot;missing&quot; =&gt; &quot;alg&quot; } |&gt; Jason . encode! ( ) |&gt; url_encode ( ) iex&gt; verify ( header &lt;&gt; &quot;.YQ.YQ&quot; , @charon_config ) { :error , &quot;malformed header&quot; } iex&gt; header = %{ &quot;alg&quot; =&gt; &quot;boom&quot; } |&gt; Jason . encode! ( ) |&gt; url_encode ( ) iex&gt; verify ( header &lt;&gt; &quot;.YQ.YQ&quot; , @charon_config ) { :error , &quot;key not found&quot; } iex&gt; header = %{ &quot;alg&quot; =&gt; &quot;HS256&quot; , &quot;kid&quot; =&gt; &quot;default&quot; } |&gt; Jason . encode! ( ) |&gt; url_encode ( ) iex&gt; verify ( header &lt;&gt; &quot;.YQ.YQ&quot; , @charon_config ) { :error , &quot;signature invalid&quot; } # supports cycling to a new signing key, while still verifying old tokens iex&gt; { :ok , token } = sign ( %{ } , @charon_config ) iex&gt; keyset = Jwt . default_keyset ( @charon_config ) iex&gt; keyset = Map . put ( keyset , &quot;ed25519_1&quot; , Jwt . gen_keypair ( :eddsa_ed25519 ) ) iex&gt; config = override_opt_mod_conf ( @charon_config , Jwt , get_keyset : fn _ -&gt; keyset end , signing_key : &quot;ed25519_1&quot; ) iex&gt; { :ok , _ } = verify ( token , config ) iex&gt; { :ok , new_token } = sign ( %{ } , config ) iex&gt; new_token == token false # an old / external / legacy token without a &quot;kid&quot; claim can still be verified # by adding a &quot;kid_not_set.&lt;alg&gt;&quot; key to the keyset # a token MUST have an alg claim, which is mandatory according to the JWT spec iex&gt; [ header , pl ] = [ %{ &quot;alg&quot; =&gt; &quot;HS256&quot; } , %{ } ] |&gt; Enum . map ( &amp; Jason . encode! / 1 ) |&gt; Enum . map ( &amp; url_encode / 1 ) iex&gt; base = &quot; \#{ header } . \#{ pl } &quot; iex&gt; key = :crypto . strong_rand_bytes ( 32 ) iex&gt; signature = :crypto . mac ( :hmac , :sha256 , key , base ) |&gt; url_encode ( ) iex&gt; token = &quot; \#{ base } . \#{ signature } &quot; iex&gt; { :error , &quot;key not found&quot; } = verify ( token , @charon_config ) iex&gt; keyset = %{ &quot;kid_not_set.HS256&quot; =&gt; { :hmac_sha256 , key } } iex&gt; config = override_opt_mod_conf ( @charon_config , Jwt , get_keyset : fn _ -&gt; keyset end ) iex&gt; { :ok , _ } = verify ( token , config )","ref":"Charon.TokenFactory.Jwt.html","title":"Charon.TokenFactory.Jwt","type":"module"},{"doc":"Get the default keyset that is used if config option :get_keyset is not set explicitly.","ref":"Charon.TokenFactory.Jwt.html#default_keyset/1","title":"Charon.TokenFactory.Jwt.default_keyset/1","type":"function"},{"doc":"Generate a new keypair for an asymmetrically signed JWT.","ref":"Charon.TokenFactory.Jwt.html#gen_keypair/1","title":"Charon.TokenFactory.Jwt.gen_keypair/1","type":"function"},{"doc":"Convert a keypair generated by gen_keypair/1 to a publishable JWK containing only the public key.","ref":"Charon.TokenFactory.Jwt.html#keypair_to_pub_jwk/1","title":"Charon.TokenFactory.Jwt.keypair_to_pub_jwk/1","type":"function"},{"doc":"","ref":"Charon.TokenFactory.Jwt.html#t:eddsa_alg/0","title":"Charon.TokenFactory.Jwt.eddsa_alg/0","type":"type"},{"doc":"","ref":"Charon.TokenFactory.Jwt.html#t:eddsa_keypair/0","title":"Charon.TokenFactory.Jwt.eddsa_keypair/0","type":"type"},{"doc":"","ref":"Charon.TokenFactory.Jwt.html#t:hmac_alg/0","title":"Charon.TokenFactory.Jwt.hmac_alg/0","type":"type"},{"doc":"","ref":"Charon.TokenFactory.Jwt.html#t:key/0","title":"Charon.TokenFactory.Jwt.key/0","type":"type"},{"doc":"","ref":"Charon.TokenFactory.Jwt.html#t:keyset/0","title":"Charon.TokenFactory.Jwt.keyset/0","type":"type"},{"doc":"","ref":"Charon.TokenFactory.Jwt.html#t:mac_alg/0","title":"Charon.TokenFactory.Jwt.mac_alg/0","type":"type"},{"doc":"","ref":"Charon.TokenFactory.Jwt.html#t:symmetric_key/0","title":"Charon.TokenFactory.Jwt.symmetric_key/0","type":"type"},{"doc":"Config module for Charon.TokenFactory.Jwt .","ref":"Charon.TokenFactory.Jwt.Config.html","title":"Charon.TokenFactory.Jwt.Config","type":"module"},{"doc":"Build config struct from enumerable (useful for passing in application environment). Raises for missing mandatory keys and sets defaults for optional keys.","ref":"Charon.TokenFactory.Jwt.Config.html#from_enum/1","title":"Charon.TokenFactory.Jwt.Config.from_enum/1","type":"function"},{"doc":"Get the config for this module from the parent Charon.Config struct.","ref":"Charon.TokenFactory.Jwt.Config.html#get_mod_config/1","title":"Charon.TokenFactory.Jwt.Config.get_mod_config/1","type":"function"},{"doc":"","ref":"Charon.TokenFactory.Jwt.Config.html#t:t/0","title":"Charon.TokenFactory.Jwt.Config.t/0","type":"type"},{"doc":"The plugs in this module (and its submodules) can be used to verify tokens. The token's presence, signature, expiration and any claims can be checked. Additionally, the token's session can be loaded and, in case of a refresh token, it can be verified that it matches the session. In case of validation errors, the plugs add an &quot;auth error&quot; to the conn, but don't raise or halt the connection immediately. This property can be used to support endpoints that work with- or without authentication, for example, or if you want to support multiple kinds of tokens. The plug verify_no_auth_error/2 can be used to actually do something if there is an error. All the plugs short-circuit, meaning that they immediately return the connection if there are errors. Using the plugs in these module, you can construct your own verification pipeline using either Plug.Builder or standard Phoenix router pipelines. Here are two examples for access- and refresh tokens, respectively, that should be a good baseline for your own pipelines. Access tokens defmodule MyApp.AccessTokenPipeline do use Plug.Builder @config Charon.Config . from_enum ( Application . compile_env! ( :my_app , :charon ) ) plug :get_token_from_auth_header plug :get_token_from_cookie , @config . access_cookie_name plug :verify_token_signature , @config plug :verify_token_nbf_claim plug :verify_token_exp_claim plug :verify_token_claim_equals , { &quot;type&quot; , &quot;access&quot; } plug :verify_no_auth_error , &amp; MyApp.TokenErrorHandler . on_error / 2 plug Charon.TokenPlugs.PutAssigns end Refresh tokens defmodule MyApp.RefreshTokenPipeline do use Plug.Builder @config Charon.Config . from_enum ( Application . compile_env! ( :my_app , :charon ) ) plug :get_token_from_auth_header plug :get_token_from_cookie , @config . refresh_cookie_name plug :verify_token_signature , @config plug :verify_token_nbf_claim plug :verify_token_exp_claim plug :verify_token_claim_equals , { &quot;type&quot; , &quot;refresh&quot; } plug :load_session , @config plug :verify_token_fresh , 10 plug :verify_no_auth_error , &amp; MyApp.TokenErrorHandler . on_error / 2 plug Charon.TokenPlugs.PutAssigns end","ref":"Charon.TokenPlugs.html","title":"Charon.TokenPlugs","type":"module"},{"doc":"Get a bearer token from the authorization header. Doctests iex&gt; conn = conn ( ) |&gt; put_req_header ( &quot;authorization&quot; , &quot;Bearer aaa&quot; ) iex&gt; conn |&gt; get_token_from_auth_header ( [ ] ) |&gt; Utils . get_auth_error ( ) nil iex&gt; conn |&gt; get_token_from_auth_header ( [ ] ) |&gt; Utils . get_token_transport ( ) :bearer iex&gt; conn |&gt; get_token_from_auth_header ( [ ] ) |&gt; Utils . get_bearer_token ( ) &quot;aaa&quot; # missing auth header iex&gt; conn = conn ( ) iex&gt; conn |&gt; get_token_from_auth_header ( [ ] ) |&gt; Utils . get_auth_error ( ) nil # auth header format must be correct iex&gt; conn = conn ( ) |&gt; put_req_header ( &quot;authorization&quot; , &quot;boom&quot; ) iex&gt; conn |&gt; get_token_from_auth_header ( [ ] ) |&gt; Utils . get_bearer_token ( ) nil iex&gt; conn = conn ( ) |&gt; put_req_header ( &quot;authorization&quot; , &quot;Bearer &quot; ) iex&gt; conn |&gt; get_token_from_auth_header ( [ ] ) |&gt; Utils . get_auth_error ( ) nil","ref":"Charon.TokenPlugs.html#get_token_from_auth_header/2","title":"Charon.TokenPlugs.get_token_from_auth_header/2","type":"function"},{"doc":"Get the token or token signature from a cookie, if: no bearer token was previously found by get_token_from_auth_header/2 OR the bearer token ends with &quot;.&quot;, in which case the cookie contents are appended to it Doctests # cookie is appended to a bearer token that ends with &quot;.&quot; iex&gt; conn = conn ( ) |&gt; set_token ( &quot;token.&quot; ) |&gt; put_req_cookie ( &quot;c&quot; , &quot;sig&quot; ) |&gt; fetch_cookies ( ) iex&gt; conn = conn |&gt; get_token_from_cookie ( &quot;c&quot; ) iex&gt; conn |&gt; Utils . get_token_transport ( ) :cookie iex&gt; conn |&gt; Utils . get_bearer_token ( ) &quot;token.sig&quot; # cookie is ignored if a bearer token is present that does not end with &quot;.&quot; iex&gt; conn = conn ( ) |&gt; set_token ( &quot;token&quot; ) |&gt; put_req_cookie ( &quot;c&quot; , &quot;sig&quot; ) |&gt; fetch_cookies ( ) iex&gt; conn = conn |&gt; get_token_from_cookie ( &quot;c&quot; ) iex&gt; conn |&gt; Utils . get_token_transport ( ) nil iex&gt; conn |&gt; Utils . get_bearer_token ( ) &quot;token&quot; # cookie contents are used as token if no bearer token was found previously iex&gt; conn = conn ( ) |&gt; put_req_cookie ( &quot;c&quot; , &quot;cookie token&quot; ) |&gt; fetch_cookies ( ) iex&gt; conn = conn |&gt; get_token_from_cookie ( &quot;c&quot; ) iex&gt; conn |&gt; Utils . get_token_transport ( ) :cookie_only iex&gt; conn |&gt; Utils . get_bearer_token ( ) &quot;cookie token&quot;","ref":"Charon.TokenPlugs.html#get_token_from_cookie/2","title":"Charon.TokenPlugs.get_token_from_cookie/2","type":"function"},{"doc":"Appends the specified cookie's content to the bearer token, if the cookie is present and the token ends with a &quot;.&quot; character. Must be used after get_token_from_auth_header/2 . Doctests iex&gt; conn = conn ( ) |&gt; set_token ( &quot;token.&quot; ) |&gt; put_req_cookie ( &quot;c&quot; , &quot;sig&quot; ) |&gt; fetch_cookies ( ) iex&gt; conn = conn |&gt; get_token_from_cookie ( &quot;c&quot; ) iex&gt; conn |&gt; Utils . get_token_transport ( ) :cookie iex&gt; conn |&gt; Utils . get_bearer_token ( ) &quot;token.sig&quot; # cookie is ignored if bearer token does not end with . iex&gt; conn = conn ( ) |&gt; set_token ( &quot;token&quot; ) |&gt; put_req_cookie ( &quot;c&quot; , &quot;sig&quot; ) |&gt; fetch_cookies ( ) iex&gt; conn = conn |&gt; get_token_from_cookie ( &quot;c&quot; ) iex&gt; conn |&gt; Utils . get_token_transport ( ) nil iex&gt; conn |&gt; Utils . get_bearer_token ( ) &quot;token&quot;","ref":"Charon.TokenPlugs.html#get_token_sig_from_cookie/2","title":"Charon.TokenPlugs.get_token_sig_from_cookie/2","type":"function"},{"doc":"Fetch the session to which the bearer token belongs. Raises on session store error. Must be used after verify_token_signature/2 . Doctests iex&gt; SessionStore . upsert ( test_session ( refresh_expires_at : 999999999999999 ) , @config ) iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;sid&quot; =&gt; &quot;a&quot; , &quot;sub&quot; =&gt; 1 , &quot;styp&quot; =&gt; &quot;full&quot; } ) iex&gt; % Session { } = conn |&gt; load_session ( @config ) |&gt; Internal . get_private ( @session ) # token payload must contain &quot;sub&quot;, &quot;sid&quot; and &quot;styp&quot; claims iex&gt; conn = conn ( ) |&gt; set_token_payload ( 1 ) iex&gt; conn |&gt; load_session ( @config ) |&gt; Utils . get_auth_error ( ) &quot;bearer token claim sub, sid or styp not found&quot; # session must be found iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;sid&quot; =&gt; &quot;a&quot; , &quot;sub&quot; =&gt; 1 , &quot;styp&quot; =&gt; &quot;full&quot; } ) iex&gt; conn |&gt; load_session ( @config ) |&gt; Utils . get_auth_error ( ) &quot;session not found&quot; iex&gt; conn ( ) |&gt; load_session ( @config ) ** (RuntimeError) must be used after verify_token_signature/2","ref":"Charon.TokenPlugs.html#load_session/2","title":"Charon.TokenPlugs.load_session/2","type":"function"},{"doc":"Make sure that no previous plug of this module added an auth error. In case of an error, on_error is called (it should probably halt the connection). Doctests iex&gt; conn = conn ( ) iex&gt; ^ conn = verify_no_auth_error ( conn , fn _conn , _error -&gt; &quot;BOOM&quot; end ) # on error, send an error response iex&gt; conn = conn ( ) |&gt; set_auth_error ( &quot;oops!&quot; ) iex&gt; conn = verify_no_auth_error ( conn , &amp; &amp;1 |&gt; send_resp ( 401 , &amp;2 ) |&gt; halt ( ) ) iex&gt; conn . halted true iex&gt; conn . resp_body &quot;oops!&quot;","ref":"Charon.TokenPlugs.html#verify_no_auth_error/2","title":"Charon.TokenPlugs.verify_no_auth_error/2","type":"function"},{"doc":"Generically verify the bearer token payload. The validation function func must return the conn or an error message. Must be used after load_session/2 . Doctests iex&gt; conn = conn ( ) |&gt; set_session ( %{ the : &quot;session&quot; } ) iex&gt; ^ conn = conn |&gt; verify_session_payload ( fn conn , %{ the : &quot;session&quot; } -&gt; conn end ) # invalid iex&gt; conn = conn ( ) |&gt; set_session ( %{ the : &quot;session&quot; } ) iex&gt; conn |&gt; verify_session_payload ( fn _conn , s -&gt; s [ :missing ] || &quot;invalid&quot; end ) |&gt; Utils . get_auth_error ( ) &quot;invalid&quot; iex&gt; conn ( ) |&gt; verify_session_payload ( fn conn , _ -&gt; conn end ) ** (RuntimeError) must be used after load_session/2","ref":"Charon.TokenPlugs.html#verify_session_payload/2","title":"Charon.TokenPlugs.verify_session_payload/2","type":"function"},{"doc":"Generically verify that the bearer token payload contains claim and that its value matches func . The function must return the conn or an error message. Must be used after verify_token_signature/2 . Doctests def verify_read_scope ( conn , value ) do if &quot;read&quot; in String . split ( value , &quot;,&quot; ) do conn else &quot;no read scope&quot; end end iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;scope&quot; =&gt; &quot;read,write&quot; } ) iex&gt; ^ conn = conn |&gt; verify_token_claim ( { &quot;scope&quot; , &amp; verify_read_scope / 2 } ) # invalid iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;scope&quot; =&gt; &quot;write&quot; } ) iex&gt; conn |&gt; verify_token_claim ( { &quot;scope&quot; , &amp; verify_read_scope / 2 } ) |&gt; Utils . get_auth_error ( ) &quot;no read scope&quot; # claim must be present iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ } ) iex&gt; conn |&gt; verify_token_claim ( { &quot;scope&quot; , &amp; verify_read_scope / 2 } ) |&gt; Utils . get_auth_error ( ) &quot;bearer token claim scope not found&quot;","ref":"Charon.TokenPlugs.html#verify_token_claim/2","title":"Charon.TokenPlugs.verify_token_claim/2","type":"function"},{"doc":"Verify that the bearer token payload contains claim and that its value is expected . Must be used after verify_token_signature/2 . Doctests iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;type&quot; =&gt; &quot;access&quot; } ) iex&gt; ^ conn = conn |&gt; verify_token_claim_equals ( { &quot;type&quot; , &quot;access&quot; } ) # invalid iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;type&quot; =&gt; &quot;refresh&quot; } ) iex&gt; conn |&gt; verify_token_claim_equals ( { &quot;type&quot; , &quot;access&quot; } ) |&gt; Utils . get_auth_error ( ) &quot;bearer token claim type invalid&quot; # claim must be present iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ } ) iex&gt; conn |&gt; verify_token_claim_equals ( { &quot;type&quot; , &quot;access&quot; } ) |&gt; Utils . get_auth_error ( ) &quot;bearer token claim type not found&quot;","ref":"Charon.TokenPlugs.html#verify_token_claim_equals/2","title":"Charon.TokenPlugs.verify_token_claim_equals/2","type":"function"},{"doc":"Verify that the bearer token payload contains claim and that its value is in expected . Must be used after verify_token_signature/2 . Doctests iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;type&quot; =&gt; &quot;access&quot; } ) iex&gt; ^ conn = conn |&gt; verify_token_claim_in ( { &quot;type&quot; , ~w(access) } ) # invalid iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;type&quot; =&gt; &quot;refresh&quot; } ) iex&gt; conn |&gt; verify_token_claim_in ( { &quot;type&quot; , ~w(access) } ) |&gt; Utils . get_auth_error ( ) &quot;bearer token claim type invalid&quot; # claim must be present iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ } ) iex&gt; conn |&gt; verify_token_claim_in ( { &quot;type&quot; , ~w(access) } ) |&gt; Utils . get_auth_error ( ) &quot;bearer token claim type not found&quot;","ref":"Charon.TokenPlugs.html#verify_token_claim_in/2","title":"Charon.TokenPlugs.verify_token_claim_in/2","type":"function"},{"doc":"Verify that the bearer token payload contains a non-expired exp (expires at) claim. Must be used after verify_token_signature/2 . Note that a token created by Charon.SessionPlugs.upsert_session/3 is guaranteed to have an exp claim that does not outlive its underlying session. Doctests iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;exp&quot; =&gt; Internal . now ( ) } ) iex&gt; ^ conn = conn |&gt; verify_token_exp_claim ( [ ] ) # some clock drift is allowed iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;exp&quot; =&gt; Internal . now ( ) - 3 } ) iex&gt; ^ conn = conn |&gt; verify_token_exp_claim ( [ ] ) # expired iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;exp&quot; =&gt; Internal . now ( ) - 6 } ) iex&gt; conn |&gt; verify_token_exp_claim ( [ ] ) |&gt; Utils . get_auth_error ( ) &quot;bearer token expired&quot; # claim must be present iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ } ) iex&gt; conn |&gt; verify_token_exp_claim ( [ ] ) |&gt; Utils . get_auth_error ( ) &quot;bearer token claim exp not found&quot;","ref":"Charon.TokenPlugs.html#verify_token_exp_claim/2","title":"Charon.TokenPlugs.verify_token_exp_claim/2","type":"function"},{"doc":"Verify that the token (either access or refresh) is fresh. A token is fresh if it belongs to the current or previous &quot;refresh token generation&quot;. A generation is a set of tokens that is created within a &quot;cycle TTL&quot; amount of seconds from when the generation is first created. A new generation is created after the cycle TTL expires. So a token must be &quot;fresh&quot;, but because of refresh race conditions caused by network issues or misbehaving clients, enforcing only a single fresh token causes too many problems in practice. Must be used after load_session/2 . Verify the token type with verify_token_claim_equals/2 . Freshness example New cycle is created 5 seconds after the generation's first token is created, and token ttl is 24h (so irrelevant in this example). When New gen Fresh tokens Created token Current gen (timestamp) Previous gen Comment 0 - A A (0) - Login 10 y A B B (10) A Refresh after cycle TTL of A, [A] becomes prev gen 11 A, B C B, C (10) A Refresh race within cycle TTL of B 12 A, B, C D B, C, D (10) A Refresh race within cycle TTL of B 20 y B, C, D E E (20) B, C, D Refresh after cycle TTL of B, so [A] is now stale, and [B,C,D] becomes prev gen 30 y E F F (30) E Refresh after cycle TTL of E, so [B,C,D] is now stale, [E] becomes prev gen Doctests # some clock drift is allowed iex&gt; now = Internal . now ( ) iex&gt; conn = conn ( ) |&gt; set_session ( %{ tokens_fresh_from : now , prev_tokens_fresh_from : now - 10 } ) |&gt; set_token_payload ( %{ &quot;iat&quot; =&gt; now - 11 } ) iex&gt; nil = conn |&gt; verify_token_fresh ( 5 ) |&gt; Utils . get_auth_error ( ) # if current gen is still within the cycle TTL, tokens from both it and previous gen are &quot;fresh&quot; iex&gt; now = Internal . now ( ) iex&gt; conn = conn ( ) |&gt; set_session ( %{ tokens_fresh_from : now - 3 , prev_tokens_fresh_from : now - 10 } ) iex&gt; nil = conn |&gt; set_token_payload ( %{ &quot;iat&quot; =&gt; now } ) |&gt; verify_token_fresh ( 5 ) |&gt; Utils . get_auth_error ( ) # tokens are invalid from: iat &lt; now - 10 (*previous* gen age) - 5 (max clock drift) # younger-than-previous-gen-and-clock-drift token is valid iex&gt; nil = conn |&gt; set_token_payload ( %{ &quot;iat&quot; =&gt; now - 15 } ) |&gt; verify_token_fresh ( 5 ) |&gt; Utils . get_auth_error ( ) # older-than-previous-gen-and-clock-drift token is invalid iex&gt; conn |&gt; set_token_payload ( %{ &quot;iat&quot; =&gt; now - 16 } ) |&gt; verify_token_fresh ( 5 ) |&gt; Utils . get_auth_error ( ) &quot;token stale&quot; # no generation cycle will take place iex&gt; conn |&gt; set_token_payload ( %{ &quot;iat&quot; =&gt; now } ) |&gt; verify_token_fresh ( 5 ) |&gt; Internal . get_private ( @cycle_token_generation ) false # if current gen is too old, a generation cycle happens, and previous gen tokens are no longer valid # tokens are invalid from: iat &lt; now - 10 (*current* gen age) - 5 (max clock drift) iex&gt; now = Internal . now ( ) iex&gt; conn = conn ( ) |&gt; set_session ( %{ tokens_fresh_from : now - 10 , prev_tokens_fresh_from : now - 20 } ) iex&gt; nil = conn |&gt; set_token_payload ( %{ &quot;iat&quot; =&gt; now } ) |&gt; verify_token_fresh ( 5 ) |&gt; Utils . get_auth_error ( ) # younger-than-current-gen-and-clock-drift token is valid iex&gt; nil = conn |&gt; set_token_payload ( %{ &quot;iat&quot; =&gt; now - 15 } ) |&gt; verify_token_fresh ( 5 ) |&gt; Utils . get_auth_error ( ) # older-than-current-gen-and-clock-drift token is invalid iex&gt; conn |&gt; set_token_payload ( %{ &quot;iat&quot; =&gt; now - 16 } ) |&gt; verify_token_fresh ( 5 ) |&gt; Utils . get_auth_error ( ) &quot;token stale&quot; # a generation cycle will occur iex&gt; conn |&gt; set_token_payload ( %{ &quot;iat&quot; =&gt; now } ) |&gt; verify_token_fresh ( 5 ) |&gt; Internal . get_private ( @cycle_token_generation ) true # claim must be present iex&gt; conn = conn ( ) |&gt; set_session ( %{ tokens_fresh_from : 0 , prev_tokens_fresh_from : 0 } ) |&gt; set_token_payload ( %{ } ) iex&gt; conn |&gt; verify_token_fresh ( 5 ) |&gt; Utils . get_auth_error ( ) &quot;bearer token claim iat not found&quot;","ref":"Charon.TokenPlugs.html#verify_token_fresh/2","title":"Charon.TokenPlugs.verify_token_fresh/2","type":"function"},{"doc":"Verify that the bearer token payload contains a valid nbf (not before) claim. Must be used after verify_token_signature/2 . Doctests iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;nbf&quot; =&gt; Internal . now ( ) } ) iex&gt; ^ conn = conn |&gt; verify_token_nbf_claim ( [ ] ) # some clock drift is allowed iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;nbf&quot; =&gt; Internal . now ( ) + 3 } ) iex&gt; ^ conn = conn |&gt; verify_token_nbf_claim ( [ ] ) # not yet valid iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;nbf&quot; =&gt; Internal . now ( ) + 6 } ) iex&gt; conn |&gt; verify_token_nbf_claim ( [ ] ) |&gt; Utils . get_auth_error ( ) &quot;bearer token not yet valid&quot; # claim must be present iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ } ) iex&gt; conn |&gt; verify_token_nbf_claim ( [ ] ) |&gt; Utils . get_auth_error ( ) &quot;bearer token claim nbf not found&quot;","ref":"Charon.TokenPlugs.html#verify_token_nbf_claim/2","title":"Charon.TokenPlugs.verify_token_nbf_claim/2","type":"function"},{"doc":"Verify that the bearer token payload contains claim , which is assumed to be an :ordset , and that ordset ( which is also assumed to be either an ordset or a single element ) is a subset of that ordset. Doctests iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;scope&quot; =&gt; ~w(a b c) } ) iex&gt; ^ conn = conn |&gt; verify_token_ordset_claim_contains ( { &quot;scope&quot; , &quot;a&quot; } ) iex&gt; ^ conn = conn |&gt; verify_token_ordset_claim_contains ( { &quot;scope&quot; , ~w(a b) } ) # invalid iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;scope&quot; =&gt; ~w(a b c) } ) iex&gt; conn |&gt; verify_token_ordset_claim_contains ( { &quot;scope&quot; , &quot;d&quot; } ) |&gt; get_auth_error ( ) &quot;bearer token claim scope does not contain [d]&quot; iex&gt; conn |&gt; verify_token_ordset_claim_contains ( { &quot;scope&quot; , ~w(d e) } ) |&gt; get_auth_error ( ) &quot;bearer token claim scope does not contain [d, e]&quot; # claim must be present iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ } ) iex&gt; conn |&gt; verify_token_ordset_claim_contains ( { &quot;scope&quot; , ~w(a b c) } ) |&gt; get_auth_error ( ) &quot;bearer token claim scope not found&quot; # WATCH OUT! # things will go horribly wrong if either the claim or the comparison value is not an ordset iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;scope&quot; =&gt; ~w(c b a) } ) iex&gt; conn |&gt; verify_token_ordset_claim_contains ( { &quot;scope&quot; , &quot;a&quot; } ) |&gt; get_auth_error ( ) &quot;bearer token claim scope does not contain [a]&quot; iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;scope&quot; =&gt; ~w(a b c) } ) iex&gt; conn |&gt; verify_token_ordset_claim_contains ( { &quot;scope&quot; , ~w(b a) } ) |&gt; get_auth_error ( ) &quot;bearer token claim scope does not contain [a]&quot;","ref":"Charon.TokenPlugs.html#verify_token_ordset_claim_contains/2","title":"Charon.TokenPlugs.verify_token_ordset_claim_contains/2","type":"function"},{"doc":"Generically verify the bearer token payload. The validation function func must return the conn or an error message. Must be used after verify_token_signature/2 . Doctests iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ } ) iex&gt; ^ conn = conn |&gt; verify_token_payload ( fn conn , _pl -&gt; conn end ) # invalid iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;scope&quot; =&gt; &quot;write&quot; } ) iex&gt; conn |&gt; verify_token_payload ( fn _conn , _pl -&gt; &quot;no read scope&quot; end ) |&gt; Utils . get_auth_error ( ) &quot;no read scope&quot; iex&gt; conn ( ) |&gt; verify_token_payload ( fn conn , _pl -&gt; conn end ) ** (RuntimeError) must be used after verify_token_signature/2","ref":"Charon.TokenPlugs.html#verify_token_payload/2","title":"Charon.TokenPlugs.verify_token_payload/2","type":"function"},{"doc":"Verify that the bearer token found by get_token_from_auth_header/2 is signed correctly. Doctests iex&gt; token = sign ( %{ &quot;msg&quot; =&gt; &quot;hurray!&quot; } ) iex&gt; conn = conn ( ) |&gt; set_token ( token ) |&gt; verify_token_signature ( @config ) iex&gt; %{ &quot;msg&quot; =&gt; &quot;hurray!&quot; } = Internal . get_private ( conn , @bearer_token_payload ) # signature must match iex&gt; token = sign ( %{ &quot;msg&quot; =&gt; &quot;hurray!&quot; } ) iex&gt; conn = conn ( ) |&gt; set_token ( token &lt;&gt; &quot;boom&quot; ) |&gt; verify_token_signature ( @config ) iex&gt; Internal . get_private ( conn , @bearer_token_payload ) nil iex&gt; Utils . get_auth_error ( conn ) &quot;bearer token signature invalid&quot; iex&gt; conn ( ) |&gt; verify_token_signature ( @config ) |&gt; Utils . get_auth_error ( ) &quot;bearer token not found&quot;","ref":"Charon.TokenPlugs.html#verify_token_signature/2","title":"Charon.TokenPlugs.verify_token_signature/2","type":"function"},{"doc":"After verifying everything you would want to verify about a token, assign the following to the conn: :user_id (bearer token claim &quot;sub&quot;) :session_id (bearer token claim &quot;sid&quot;) :token_payload :session (if fetched with Charon.TokenPlugs.load_session/2 ) All of the assign names are overridable: # assign the user ID to key :current_user_id plug PutAssigns , claims : %{ &quot;sub&quot; =&gt; :current_user_id , &quot;sid&quot; =&gt; :session_id } Doctests iex&gt; opts = PutAssigns . init ( [ ] ) iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;sub&quot; =&gt; 1 , &quot;sid&quot; =&gt; &quot;a&quot; } ) iex&gt; conn |&gt; PutAssigns . call ( opts ) |&gt; Map . get ( :assigns ) %{ session_id : &quot;a&quot; , token_payload : %{ &quot;sid&quot; =&gt; &quot;a&quot; , &quot;sub&quot; =&gt; 1 } , user_id : 1 } iex&gt; opts = PutAssigns . init ( session : :da_session_baby ) iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;sub&quot; =&gt; 1 , &quot;sid&quot; =&gt; &quot;a&quot; } ) |&gt; set_session ( &quot;hii&quot; ) iex&gt; conn |&gt; PutAssigns . call ( opts ) |&gt; Map . get ( :assigns ) %{ session_id : &quot;a&quot; , token_payload : %{ &quot;sid&quot; =&gt; &quot;a&quot; , &quot;sub&quot; =&gt; 1 } , user_id : 1 , da_session_baby : &quot;hii&quot; } # skipped on auth error iex&gt; opts = PutAssigns . init ( [ ] ) iex&gt; conn = conn ( ) |&gt; set_token_payload ( %{ &quot;sub&quot; =&gt; 1 , &quot;sid&quot; =&gt; &quot;a&quot; } ) |&gt; set_auth_error ( &quot;boom&quot; ) iex&gt; conn |&gt; PutAssigns . call ( opts ) |&gt; Map . get ( :assigns ) %{ }","ref":"Charon.TokenPlugs.PutAssigns.html","title":"Charon.TokenPlugs.PutAssigns","type":"module"},{"doc":"Utility functions, mainly getters and setters for module internals.","ref":"Charon.Utils.html","title":"Charon.Utils","type":"module"},{"doc":"Get auth errors, if present.","ref":"Charon.Utils.html#get_auth_error/1","title":"Charon.Utils.get_auth_error/1","type":"function"},{"doc":"Get the bearer token, if present.","ref":"Charon.Utils.html#get_bearer_token/1","title":"Charon.Utils.get_bearer_token/1","type":"function"},{"doc":"Get the payload of the bearer token, if present.","ref":"Charon.Utils.html#get_bearer_token_payload/1","title":"Charon.Utils.get_bearer_token_payload/1","type":"function"},{"doc":"Get current session, if present.","ref":"Charon.Utils.html#get_session/1","title":"Charon.Utils.get_session/1","type":"function"},{"doc":"Get token signature transport mechanism, if present.","ref":"Charon.Utils.html#get_token_signature_transport/1","title":"Charon.Utils.get_token_signature_transport/1","type":"function"},{"doc":"Get token transport mechanism, if present.","ref":"Charon.Utils.html#get_token_transport/1","title":"Charon.Utils.get_token_transport/1","type":"function"},{"doc":"Get tokens, if present.","ref":"Charon.Utils.html#get_tokens/1","title":"Charon.Utils.get_tokens/1","type":"function"},{"doc":"Put an auth error on the conn","ref":"Charon.Utils.html#set_auth_error/2","title":"Charon.Utils.set_auth_error/2","type":"function"},{"doc":"Put a session on the conn","ref":"Charon.Utils.html#set_session/2","title":"Charon.Utils.set_session/2","type":"function"},{"doc":"Put a token on the conn","ref":"Charon.Utils.html#set_token/2","title":"Charon.Utils.set_token/2","type":"function"},{"doc":"Put a token payload on the conn","ref":"Charon.Utils.html#set_token_payload/2","title":"Charon.Utils.set_token_payload/2","type":"function"},{"doc":"Set token signature transport mechanism. Must be one of &quot;bearer&quot; , &quot;cookie_only&quot; , &quot;cookie&quot; :bearer , :cookie_only or :cookie . This function only results in transports :bearer and :cookie , never in :cookie_only , in contrast with set_token_signature_transport/2 , to maintain backwards compatibility. Examples / doctests iex&gt; :bearer = % Conn { } |&gt; set_token_signature_transport ( &quot;bearer&quot; ) |&gt; get_token_signature_transport ( ) iex&gt; :bearer = % Conn { } |&gt; set_token_signature_transport ( :bearer ) |&gt; get_token_signature_transport ( ) iex&gt; :cookie = % Conn { } |&gt; set_token_signature_transport ( &quot;cookie_only&quot; ) |&gt; get_token_signature_transport ( ) iex&gt; :cookie = % Conn { } |&gt; set_token_signature_transport ( :cookie_only ) |&gt; get_token_signature_transport ( ) iex&gt; :cookie = % Conn { } |&gt; set_token_signature_transport ( &quot;cookie&quot; ) |&gt; get_token_signature_transport ( ) iex&gt; :cookie = % Conn { } |&gt; set_token_signature_transport ( :cookie ) |&gt; get_token_signature_transport ( )","ref":"Charon.Utils.html#set_token_signature_transport/2","title":"Charon.Utils.set_token_signature_transport/2","type":"function"},{"doc":"Set user id for session creation","ref":"Charon.Utils.html#set_user_id/2","title":"Charon.Utils.set_user_id/2","type":"function"},{"doc":"Derive a key from a base secret using PBKDF2.","ref":"Charon.Utils.KeyGenerator.html","title":"Charon.Utils.KeyGenerator","type":"module"},{"doc":"Derive a new key from base_secret using salt . The result is cached using FastGlobal with key Elixir.Charon.Utils.KeyGenerator . Options :length key length in bytes, default 32 (256 bits) :iterations hash iterations to derive new key, default 250_000 :digest hashing algorithm used as pseudo-random function, default :sha256 Doctests iex&gt; derive_key ( &quot;secret&quot; , &quot;salt&quot; , length : 5 , iterations : 1 ) &lt;&lt; 56 , 223 , 66 , 139 , 48 &gt;&gt; # key is returned from cache based on function args iex&gt; FastGlobal . put ( KeyGenerator , %{ { &quot;secret&quot; , &quot;salt&quot; , [ length : 5 , iterations : 1 ] } =&gt; &quot;supersecret&quot; } ) iex&gt; derive_key ( &quot;secret&quot; , &quot;salt&quot; , length : 5 , iterations : 1 ) &quot;supersecret&quot;","ref":"Charon.Utils.KeyGenerator.html#derive_key/3","title":"Charon.Utils.KeyGenerator.derive_key/3","type":"function"},{"doc":"","ref":"Charon.Utils.KeyGenerator.html#t:opts/0","title":"Charon.Utils.KeyGenerator.opts/0","type":"type"},{"doc":"Error raised when token transport method &quot;bearer&quot; is requested by a browser client.","ref":"Charon.SessionPlugs.InsecureTokenTransportError.html","title":"Charon.SessionPlugs.InsecureTokenTransportError","type":"exception"},{"doc":"Error raised when a new/updated session could not be stored.","ref":"Charon.SessionPlugs.SessionStorageError.html","title":"Charon.SessionPlugs.SessionStorageError","type":"exception"},{"doc":"Error raised on an optimistic locking error when updating an existing session.","ref":"Charon.SessionPlugs.SessionUpdateConflictError.html","title":"Charon.SessionPlugs.SessionUpdateConflictError","type":"exception"},{"doc":"Charon is an extensible auth framework for Elixir, mostly for API's. The base package provides token generation &amp; verification, and session handling. Additional functionality can be added with child packages. The package is opinionated with sane config defaults as much as possible.","ref":"readme.html","title":"Charon","type":"extras"},{"doc":"Charon Table of contents Features Child packages Documentation How to use Installation Configuration Setting up a session store Protecting routes Logging in, logging out and refreshing Testing Copyright and License","ref":"readme.html#table-of-contents","title":"Charon - Table of contents","type":"extras"},{"doc":"Striking a &quot;statefulness&quot; balance is left to the application. By default, access token are fully stateless, and refresh tokens are backed by a server-side session. A single base secret is used to derive special-purpose keys (like Phoenix's :secret_key_base ), simplifying key management Tokens are generated by a factory behaviour with a default implementation using symmetric-key signed JWT's. Default token factory supports key rotation (including new derived keys) Default token factory supports asymmetric signatures using EdDSA with Ed25519 or Ed448 curves. Token verification is completely customizable using simple helper functions. Sessions are managed by a session store behaviour with a default implementation using Redis. To support both web- and other clients, it is possible to &quot;split-off&quot; the token's signatures and put them in cookies (to prevent storing tokens in LocalStorage and other insecure storage). This idea is inspired by this excellent Medium article by Peter Locke. Flexible configuration that does not (have to) depend on the application environment. Small number of dependencies.","ref":"readme.html#features","title":"Charon - Features","type":"extras"},{"doc":"CharonAbsinthe for using Charon with Absinthe. CharonOauth2 adds Oauth2 authorization server capability. CharonLogin adds authentication flows/challenges to generically provide login checks like password and MFA. (planned) CharonSocial for social login. (planned) CharonPermissions for authorization checks.","ref":"readme.html#child-packages","title":"Charon - Child packages","type":"extras"},{"doc":"Documentation can be found at https://hexdocs.pm/charon .","ref":"readme.html#documentation","title":"Charon - Documentation","type":"extras"},{"doc":"Installation The package can be installed by adding charon to your list of dependencies in mix.exs : def deps do [ { :charon , &quot;~&gt; 3.0&quot; } ] end Configuration Configuration has been made easy using a config helper struct Charon.Config , which has a function from_enum/1 that verifies that your config is complete and valid, raising on missing fields. By using multiple config structs, you can support multiple configurations within a single application. The main reason to use multiple sets of configuration is that you can support different auth requirements in this way. You could, for example, create a never-expiring session for ordinary users and create a short-lived session for application admins. # Charon itself only requires a token issuer and a base secret getter. @my_config Charon.Config . from_enum ( token_issuer : &quot;MyApp&quot; , get_base_secret : &amp; MyApp . get_base_secret / 0 ) # it is possible to use the application environment as well if you wish @my_config Application . compile_env ( :my_app , :charon ) |&gt; Charon.Config . from_enum ( ) Setting up a session store A session store can be created using multiple state stores, be it a database or a GenServer. All you have to do is implement a simple behaviour which you can find in Charon.SessionStore.Behaviour . Two default implementations are provided, Charon.SessionStore.RedisStore uses a Redis database, Charon.SessionStore.LocalStore uses a GenServer. Use Charon.SessionStore.DummyStore in case you don't want to use server-side sessions and prefer fully stateless tokens. The default and recommended option is RedisStore. Use LocalStore for local testing only - it is NOT persistent. In order to use RedisStore, add Charon.SessionStore.RedisStore to your supervision tree: # application.ex def start ( _ , ) do redix_opts = [ host : &quot;localhost&quot; , port : 6379 , password : &quot;supersecret&quot; , database : 0 ] children = [ ... { Charon.SessionStore.RedisStore , pool_size : 15 , redix_opts : redix_opts } , ... ] opts = [ strategy : :one_for_one , name : MyApp.Supervisor ] Supervisor . start_link ( children , opts ) end Setting up a token factory The default token factory is Charon.TokenFactory.Jwt , which requires no configuration by default, and uses symmetric HMAC-SHA256 signatures and a derived key. You can override its settings or set up your own TokenFactory by implementing Charon.TokenFactory.Behaviour . Protecting routes Verifying incoming tokens is supported by the plugs in Charon.TokenPlugs (and submodules). You can use these plugs to create pipelines to verify the tokens and their claims. Note that the plugs don't halt the connection until you call Charon.TokenPlugs.verify_no_auth_error/2 , but further processing stops as soon as a previous plug adds an error to the conn. Example access- and refresh token pipelines: defmodule MyApp.AccessTokenPipeline do @moduledoc &quot;&quot;&quot; Verify access tokens. A access token: - must have a valid signature - must not be expired (and already valid) - must have a &quot;type&quot; claim with value &quot;access&quot; &quot;&quot;&quot; use Plug.Builder import Charon.TokenPlugs @config Application . compile_env ( :my_app , :charon ) |&gt; Charon.Config . from_enum ( ) plug :get_token_from_auth_header plug :get_token_from_cookie , @config . access_cookie_name plug :verify_token_signature , @config plug :verify_token_nbf_claim plug :verify_token_exp_claim plug :verify_token_claim_equals , { &quot;type&quot; , &quot;access&quot; } plug :verify_no_auth_error , &amp; MyApp.TokenErrorHandler . on_error / 2 plug Charon.TokenPlugs.PutAssigns end defmodule MyApp.RefreshTokenPipeline do @moduledoc &quot;&quot;&quot; Verify refresh tokens. A refresh token: - must have a valid signature - must not be expired (and already valid) - must have a &quot;type&quot; claim with value &quot;refresh&quot; - must have a corresponding session - must be fresh (see `Charon.TokenPlugs.verify_token_fresh/2` docs) &quot;&quot;&quot; use Plug.Builder import Charon.TokenPlugs @config Application . compile_env ( :my_app , :charon ) |&gt; Charon.Config . from_enum ( ) plug :get_token_from_auth_header plug :get_token_from_cookie , @config . refresh_cookie_name plug :verify_token_signature , @config plug :verify_token_nbf_claim plug :verify_token_exp_claim plug :verify_token_claim_equals , { &quot;type&quot; , &quot;refresh&quot; } plug :load_session , @config plug :verify_token_fresh , 10 plug :verify_no_auth_error , &amp; MyApp.TokenErrorHandler . on_error / 2 plug Charon.TokenPlugs.PutAssigns end # use the pipelines in your router defmodule MyAppWeb.Router do use MyAppWeb , :router pipeline :api do plug :accepts , [ &quot;json&quot; ] end pipeline :valid_access_token do # or just use the token plugs right here instead of putting them in a separate module plug MyApp.AccessTokenPipeline end pipeline :valid_refresh_token do plug MyApp.RefreshTokenPipeline end scope &quot;/&quot; do pipe_through [ :api ] post &quot;/current_session&quot; , SessionController , :login end scope &quot;/&quot; do pipe_through [ :api , :valid_access_token ] delete &quot;/current_session&quot; , SessionController , :logout end scope &quot;/&quot; do pipe_through [ :api , :valid_refresh_token ] # optionally limit the refresh cookie path to this path using `Config.refresh_cookie_opts` post &quot;/current_session/refresh&quot; , SessionController , :refresh end end Logging in, logging out and refreshing Create a session controller with login, logout and refresh routes. You can use Charon.SessionPlugs for all operations. defmodule MyAppWeb.SessionController do @moduledoc &quot;&quot;&quot; Controller for a user&#39;s session(s), including login, logout and refresh. &quot;&quot;&quot; use MyAppWeb , :controller alias Charon . { SessionPlugs , Utils } alias MyApp . { User , Users } @config Application . compile_env ( :my_app , :charon ) |&gt; Charon.Config . from_enum ( ) @doc &quot;&quot;&quot; Login to my app! &quot;&quot;&quot; def login ( conn , %{ &quot;email&quot; =&gt; email , &quot;password&quot; =&gt; password , &quot;token_transport&quot; =&gt; token_transport } ) when token_transport in ~w(bearer cookie_only cookie) do with { :ok , user } &lt;- Users . get_by ( email : email ) |&gt; Users . verify_password ( password ) do # you can do extra checks here, like checking if the user is active, for example conn # you can add/override claims in the tokens (be careful!) |&gt; SessionPlugs . upsert_session ( @config , user_id : user . id , token_transport : token_transport , access_claim_overrides : %{ &quot;roles&quot; =&gt; user . roles } ) |&gt; put_status ( 201 ) |&gt; send_token_response ( user ) else _error -&gt; send_resp ( conn , 401 , &quot;user not found or wrong password&quot; ) end end @doc &quot;&quot;&quot; Logout from my app! &quot;&quot;&quot; def logout ( conn , _params ) do conn |&gt; SessionPlugs . delete_session ( @config ) |&gt; send_resp ( 204 , &quot;&quot; ) end @doc &quot;&quot;&quot; Stay fresh with my app! &quot;&quot;&quot; def refresh ( %{ assigns : %{ current_user_id : user_id } } = conn , _params ) do with % User { status : &quot;active&quot; } = user &lt;- Users . get_by ( id : user_id ) do # here you can do extra checks again conn # there&#39;s no need to set user_id, token transport or extra session payload # because these are grabbed from the current session # but all added/overridden token claims must be passed in again |&gt; SessionPlugs . upsert_session ( @config , access_claim_overrides : %{ &quot;roles&quot; =&gt; user . roles } ) |&gt; send_token_response ( user ) else _error -&gt; send_resp ( conn , 401 , &quot;user not found or inactive&quot; ) end end ########### # Private # ########### defp send_token_response ( conn , user ) do session = conn |&gt; Utils . get_session ( ) |&gt; Map . from_struct ( ) tokens = conn |&gt; Utils . get_tokens ( ) |&gt; Map . from_struct ( ) json ( conn , %{ tokens : tokens , session : session } ) end end And that's it :) Optionally, you can add get-all, logout-all and logout-other session endpoints, if your session store supports it (the default Redis one does). Testing To aid in testing, some utility functions have been added for your convenience. defmodule MyAppWeb.ControllerTest do use MyAppWeb.ConnCase alias Charon.TestHelpers alias MyApp.User setup seeds do # create a user somehow... user = % User { id : 1 } # create a valid session with tokens and put the access token on the conn conn = TestHelpers . put_token ( conn , user . id , MyAppWeb.Charon . config ( ) ) [ conn : conn ] end end","ref":"readme.html#how-to-use","title":"Charon - How to use","type":"extras"},{"doc":"Copyright (c) 2023, YipYip B.V. Charon source code is licensed under the Apache-2.0 License","ref":"readme.html#copyright-and-license","title":"Charon - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0 , January 2004 http :// www . apache . org / licenses / TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License ; and (b) You must cause any modified files to carry prominent notices stating that You changed the files ; and (c) You must retain, in the Source form of any Derivative Works that You distribute , all copyright , patent , trademark , and attribution notices from the Source form of the Work , excluding those notices that do not pertain to any part of the Derivative Works ; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution , then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file , excluding those notices that do not pertain to any part of the Derivative Works , in at least one of the following places : within a NOTICE text file distributed as part of the Derivative Works ; within the Source form or documentation , if provided along with the Derivative Works ; or , within a display generated by the Derivative Works , if and wherever such third - party notices normally appear . The contents of the NOTICE file are for informational purposes only and do not modify the License . You may add Your own attribution notices within Derivative Works that You distribute , alongside or as an addendum to the NOTICE text from the Work , provided that such additional attribution notices cannot be construed as modifying the License . You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"","ref":"upgrade_guide.html","title":"Upgrade guide","type":"extras"},{"doc":"RedisStore changes If you use Charon.SessionStore.RedisStore you must do the following before upgrading to 3.x: Update Charon to &gt;= 2.8.0 Upgrade your Redis instance to 7.x.x (this can be an in-place upgrade) Run Charon.SessionStore.RedisStore.migrate_sessions/1 If you explicitly set config options :allow_unsigned? and :redix_module , you must remove your overrides. Support for these config options has been dropped. Initialize the Redix connection pool in your supervision tree. See readme section setting up a sessionstore . Remove your Redix module (if you don't use it for anything else). Deprecated functions All marked-as-deprecated functions have been dropped, so make sure your code does not use these functions anymore. The compiler emits warnings if you do.","ref":"upgrade_guide.html#2-x-to-3-x","title":"Upgrade guide - 2.x to 3.x","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Breaking Charon.SessionStore.RedisStore requires Redis &gt;= 7.x.x uses a Redix connection pool by itself, which requires initialization under the application supervision tree implements optimistic locking uses a new storage format based on hash sets, to which sessions are migrated starting from Charon 2.8 uses Redis functions to implement all session store operations in a single round trip to the Redis instance support for unsigned binaries has been dropped config options :allow_unsigned? has been removed migrate_sessions/1 has been removed sessions that have not been migrated using migrate_sessions/1 can no longer be used Charon.SessionStore.LocalStore implements optimistic locking 2.x marked-deprecated functions have been removed: Charon.Models.Session.deserialize/2 Charon.Models.Session.serialize/1 Charon.SessionStore.delete/3 Charon.SessionStore.get/3 Charon.SessionStore.delete_all/2 Charon.SessionStore.get_all/2 Charon.SessionStore.RedisStore.cleanup/1 Charon.TokenPlugs.verify_refresh_token_fresh/2 Charon.TokenPlugs.verify_token_signature/2 no longer adds default value &quot;full&quot; for claim &quot;styp&quot;. This should not result in issues for tokens created by Charon 2.x.x deployments. Older deployments may wish to add a plug after Charon.TokenPlugs.verify_token_signature/2 that adds this default claim.","ref":"changelog.html#3-x","title":"Changelog - 3.x","type":"extras"}]